using System;
using System.Drawing;
using System.Data ;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Samples.WebReferenceForDataAccess ;	// EFuT[rXQ

namespace Samples
{
	public class AddressBookWithWebService : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox inputId;		// ID͗peLXg{bNX
		private System.Windows.Forms.TextBox inputName;		// Z͗peLXg{bNX
		private System.Windows.Forms.TextBox inputMemo;		// l͗peLXg{bNX
		private System.Windows.Forms.Button execLoad;		// R[hǂݍ݃{^
		private System.Windows.Forms.Button execInsert;		// R[hǉ{^
		private System.Windows.Forms.Button execUpdate;		// R[hXV{^
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox inputAddress;

		private DataAccessWebService dataAccess ;				// f[^x[XANZXp

		public AddressBookWithWebService()
		{
			InitializeComponent();
			dataAccess = new DataAccessWebService() ;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.inputId = new System.Windows.Forms.TextBox();
			this.inputName = new System.Windows.Forms.TextBox();
			this.inputAddress = new System.Windows.Forms.TextBox();
			this.inputMemo = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.execInsert = new System.Windows.Forms.Button();
			this.execUpdate = new System.Windows.Forms.Button();
			this.execLoad = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// inputId
			// 
			this.inputId.ImeMode = System.Windows.Forms.ImeMode.Disable;
			this.inputId.Location = new System.Drawing.Point(40, 32);
			this.inputId.MaxLength = 8;
			this.inputId.Name = "inputId";
			this.inputId.Size = new System.Drawing.Size(56, 19);
			this.inputId.TabIndex = 0;
			this.inputId.Text = "";
			// 
			// inputName
			// 
			this.inputName.Location = new System.Drawing.Point(40, 56);
			this.inputName.Name = "inputName";
			this.inputName.Size = new System.Drawing.Size(112, 19);
			this.inputName.TabIndex = 2;
			this.inputName.Text = "";
			// 
			// inputAddress
			// 
			this.inputAddress.Location = new System.Drawing.Point(40, 80);
			this.inputAddress.Name = "inputAddress";
			this.inputAddress.Size = new System.Drawing.Size(232, 19);
			this.inputAddress.TabIndex = 3;
			this.inputAddress.Text = "";
			// 
			// inputMemo
			// 
			this.inputMemo.Location = new System.Drawing.Point(40, 104);
			this.inputMemo.Multiline = true;
			this.inputMemo.Name = "inputMemo";
			this.inputMemo.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.inputMemo.Size = new System.Drawing.Size(232, 72);
			this.inputMemo.TabIndex = 4;
			this.inputMemo.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 16);
			this.label1.TabIndex = 8;
			this.label1.Text = "ID";
			this.label1.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 9;
			this.label2.Text = "";
			this.label2.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 80);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 16);
			this.label3.TabIndex = 10;
			this.label3.Text = "Z";
			this.label3.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 104);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(32, 16);
			this.label4.TabIndex = 11;
			this.label4.Text = "l";
			this.label4.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("MS UI Gothic", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.label5.Location = new System.Drawing.Point(72, 8);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(144, 16);
			this.label5.TabIndex = 7;
			this.label5.Text = "Z^Tv";
			this.label5.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// execInsert
			// 
			this.execInsert.Location = new System.Drawing.Point(120, 184);
			this.execInsert.Name = "execInsert";
			this.execInsert.Size = new System.Drawing.Size(72, 23);
			this.execInsert.TabIndex = 5;
			this.execInsert.Text = "ǉ";
			this.execInsert.Click += new System.EventHandler(this.execInsert_Click);
			// 
			// execUpdate
			// 
			this.execUpdate.Location = new System.Drawing.Point(200, 184);
			this.execUpdate.Name = "execUpdate";
			this.execUpdate.Size = new System.Drawing.Size(72, 23);
			this.execUpdate.TabIndex = 6;
			this.execUpdate.Text = "XV";
			this.execUpdate.Click += new System.EventHandler(this.execUpdate_Click);
			// 
			// execLoad
			// 
			this.execLoad.Location = new System.Drawing.Point(104, 31);
			this.execLoad.Name = "execLoad";
			this.execLoad.Size = new System.Drawing.Size(48, 21);
			this.execLoad.TabIndex = 1;
			this.execLoad.Text = "Ǎ";
			this.execLoad.Click += new System.EventHandler(this.execLoad_Click);
			// 
			// AddressBookWithWebService
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(288, 213);
			this.Controls.Add(this.execLoad);
			this.Controls.Add(this.execUpdate);
			this.Controls.Add(this.execInsert);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.inputMemo);
			this.Controls.Add(this.inputAddress);
			this.Controls.Add(this.inputName);
			this.Controls.Add(this.inputId);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "AddressBookWithWebService";
			this.Text = "Z^Tv(WebT[rX)";
			this.ResumeLayout(false);

		}
		#endregion

		static void Main() 
		{
			Application.Run( new AddressBookWithWebService() ) ;
		}

		private void execLoad_Click(object sender, System.EventArgs e)
		{
			if ( this.inputId.Text == string.Empty )
			{
				MessageBox.Show( "ID͂ĉ" ) ;
			}
			else
			{
				DataSet receiveSet ;	// SQLʊi[pf[^Zbg
				DataRow receiveRow ;	// SQLʂ̍ŏ̍s̊i[p
				receiveSet = dataAccess.Request( this.inputId.Text ) ;
				if ( receiveSet.Tables.Count > 0 && receiveSet.Tables[ 0 ].Rows.Count > 0 )
				{
					receiveRow = receiveSet.Tables[ 0 ].Rows[ 0 ] ;
					this.inputName.Text = receiveRow[ "" ].ToString() ;
					this.inputAddress.Text = receiveRow[ "Z" ].ToString() ;
					this.inputMemo.Text = receiveRow[ "l" ].ToString() ;
				}
				else
				{
					MessageBox.Show( "f[^܂" ) ;
				}
			}
		}

		private void execInsert_Click(object sender, System.EventArgs e)
		{
			System.Text.StringBuilder message ;	// mFbZ[W

			message = new System.Text.StringBuilder( "ȉ̓eŏZ^ɒǉ܂\n" ) ;
			message.Append( "\n : " ) ;
			message.Append( this.inputName.Text ) ;
			message.Append( "\nZ : " ) ;
			message.Append( this.inputAddress.Text ) ;
			message.Append( "\nl : " ) ;
			message.Append( this.inputMemo.Text ) ;
			message.Append( "\n\n낵łH" ) ;

			if ( MessageBox.Show( message.ToString() , "ǉ" ,
				MessageBoxButtons.OKCancel ,
				MessageBoxIcon.Question )
				== DialogResult.OK )
			{
				if ( dataAccess.Insert(
					this.inputName.Text ,
					this.inputAddress.Text ,
					this.inputMemo.Text ) )
				{
					MessageBox.Show( "R[hǉ܂" ) ;
				}
				else
				{
					MessageBox.Show( "R[hǉ܂ł" ) ;
				}
			}
		}

		private void execUpdate_Click(object sender, System.EventArgs e)
		{
			System.Text.StringBuilder message ; // mFbZ[W
			int rowQuantity ;					// ߂l(ʂ̍s)i[p

			message = new System.Text.StringBuilder( "ȉ̓eID:" ) ;
			message.Append( this.inputId.Text ) ;
			message.Append( "̃R[hXV܂\n" ) ;
			message.Append( "\n : " ) ;
			message.Append( this.inputName.Text ) ;
			message.Append( "\nZ : " ) ;
			message.Append( this.inputAddress.Text ) ;
			message.Append( "\nl : " ) ;
			message.Append( this.inputMemo.Text ) ;
			message.Append( "\n\n낵łH" ) ;

			if ( MessageBox.Show( message.ToString() , "XV" ,
				MessageBoxButtons.OKCancel ,
				MessageBoxIcon.Question )
				== DialogResult.OK )
			{
				rowQuantity = dataAccess.Update(
					this.inputId.Text ,
					this.inputName.Text ,
					this.inputAddress.Text ,
					this.inputMemo.Text ) ;
				if ( rowQuantity == 1 )
				{
					MessageBox.Show( "R[hXV܂" ) ;
				}
				else if ( rowQuantity == 0 )
				{
					MessageBox.Show( "ID:" + this.inputId.Text + "̃R[h܂ł" ) ;
				}
				else
				{
					MessageBox.Show( "R[hXV܂ł" ) ;
				}
			}		
		}
	}
}
