using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using SampleWebSite.WebReferenceForDataAccess ;

namespace SampleWebSite
{
	public class AddressBook : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox inputId;
		protected System.Web.UI.WebControls.TextBox inputName;
		protected System.Web.UI.WebControls.TextBox inputAddress;
		protected System.Web.UI.WebControls.TextBox inputMemo;
		protected System.Web.UI.WebControls.Button execLoad;
		protected System.Web.UI.WebControls.Button execInsert;
		protected System.Web.UI.WebControls.Button execUpdate;
		protected System.Web.UI.HtmlControls.HtmlForm AdressBookForm;
		protected System.Web.UI.WebControls.Label message;

		private void Page_Load(object sender, System.EventArgs e)
		{
			message.Text = string.Empty ;
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.execLoad.Click += new System.EventHandler(this.execLoad_Click);
			this.execInsert.Click += new System.EventHandler(this.execInsert_Click);
			this.execUpdate.Click += new System.EventHandler(this.execUpdate_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void execLoad_Click(object sender, System.EventArgs e)
		{
			DataAccessWebService dataAccess ;
			dataAccess = new DataAccessWebService() ;

			if ( this.inputId.Text == string.Empty )
			{
				message.Text = "ID͂ĉ" ;
			}
			else
			{
				DataSet receiveSet ;	// SQLʊi[pf[^Zbg
				DataRow receiveRow ;	// SQLʂ̍ŏ̍s̊i[p
				receiveSet = dataAccess.Request( this.inputId.Text ) ;
				if ( receiveSet.Tables.Count > 0 && receiveSet.Tables[ 0 ].Rows.Count > 0 )
				{
					receiveRow = receiveSet.Tables[ 0 ].Rows[ 0 ] ;
					this.inputName.Text = receiveRow[ "" ].ToString() ;
					this.inputAddress.Text = receiveRow[ "Z" ].ToString() ;
					this.inputMemo.Text = receiveRow[ "l" ].ToString() ;
				}
				else
				{
					this.inputId.Text = string.Empty ;
					this.inputName.Text = string.Empty ;
					this.inputAddress.Text = string.Empty ;
					this.inputMemo.Text = string.Empty ;

					message.Text = "f[^܂" ;
				}
			}
		}

		private void execInsert_Click(object sender, System.EventArgs e)
		{
			DataAccessWebService dataAccess ;
			dataAccess = new DataAccessWebService() ;

			if ( dataAccess.Insert(
				this.inputName.Text ,
				this.inputAddress.Text ,
				this.inputMemo.Text ) )
			{
				message.Text = "R[hǉ܂" ;
			}
			else
			{
				message.Text = "R[hǉ܂ł" ;
			}
		}

		private void execUpdate_Click(object sender, System.EventArgs e)
		{
			DataAccessWebService dataAccess ;
			dataAccess = new DataAccessWebService() ;
			int rowQuantity ;					// ߂l(ʂ̍s)i[p

			rowQuantity = dataAccess.Update(
				this.inputId.Text ,
				this.inputName.Text ,
				this.inputAddress.Text ,
				this.inputMemo.Text ) ;
			if ( rowQuantity == 1 )
			{
				message.Text = "R[hXV܂" ;
			}
			else if ( rowQuantity == 0 )
			{
				message.Text = "ID:" + this.inputId.Text + "̃R[h܂ł" ;
			}
			else
			{
				message.Text = "R[hXV܂ł" ;
			}
		}		
	}
}
